// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/GearReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'gear'
// Member 'cmd'
// Member 'driver'
#include "ds_dbw_msgs/msg/detail/gear__struct.hpp"
// Member 'reject'
#include "ds_dbw_msgs/msg/detail/gear_reject__struct.hpp"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__GearReport __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__GearReport __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct GearReport_
{
  using Type = GearReport_<ContainerAllocator>;

  explicit GearReport_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    gear(_init),
    cmd(_init),
    driver(_init),
    reject(_init),
    cmd_src(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->power_latched = false;
      this->external_control = false;
      this->ready = false;
      this->override_active = false;
      this->override_other = false;
      this->fault = false;
      this->bad_crc = false;
      this->degraded = false;
    }
  }

  explicit GearReport_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    gear(_alloc, _init),
    cmd(_alloc, _init),
    driver(_alloc, _init),
    reject(_alloc, _init),
    cmd_src(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->power_latched = false;
      this->external_control = false;
      this->ready = false;
      this->override_active = false;
      this->override_other = false;
      this->fault = false;
      this->bad_crc = false;
      this->degraded = false;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _gear_type =
    ds_dbw_msgs::msg::Gear_<ContainerAllocator>;
  _gear_type gear;
  using _cmd_type =
    ds_dbw_msgs::msg::Gear_<ContainerAllocator>;
  _cmd_type cmd;
  using _driver_type =
    ds_dbw_msgs::msg::Gear_<ContainerAllocator>;
  _driver_type driver;
  using _reject_type =
    ds_dbw_msgs::msg::GearReject_<ContainerAllocator>;
  _reject_type reject;
  using _power_latched_type =
    bool;
  _power_latched_type power_latched;
  using _external_control_type =
    bool;
  _external_control_type external_control;
  using _ready_type =
    bool;
  _ready_type ready;
  using _override_active_type =
    bool;
  _override_active_type override_active;
  using _override_other_type =
    bool;
  _override_other_type override_other;
  using _fault_type =
    bool;
  _fault_type fault;
  using _bad_crc_type =
    bool;
  _bad_crc_type bad_crc;
  using _degraded_type =
    bool;
  _degraded_type degraded;
  using _cmd_src_type =
    ds_dbw_msgs::msg::CmdSrc_<ContainerAllocator>;
  _cmd_src_type cmd_src;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__gear(
    const ds_dbw_msgs::msg::Gear_<ContainerAllocator> & _arg)
  {
    this->gear = _arg;
    return *this;
  }
  Type & set__cmd(
    const ds_dbw_msgs::msg::Gear_<ContainerAllocator> & _arg)
  {
    this->cmd = _arg;
    return *this;
  }
  Type & set__driver(
    const ds_dbw_msgs::msg::Gear_<ContainerAllocator> & _arg)
  {
    this->driver = _arg;
    return *this;
  }
  Type & set__reject(
    const ds_dbw_msgs::msg::GearReject_<ContainerAllocator> & _arg)
  {
    this->reject = _arg;
    return *this;
  }
  Type & set__power_latched(
    const bool & _arg)
  {
    this->power_latched = _arg;
    return *this;
  }
  Type & set__external_control(
    const bool & _arg)
  {
    this->external_control = _arg;
    return *this;
  }
  Type & set__ready(
    const bool & _arg)
  {
    this->ready = _arg;
    return *this;
  }
  Type & set__override_active(
    const bool & _arg)
  {
    this->override_active = _arg;
    return *this;
  }
  Type & set__override_other(
    const bool & _arg)
  {
    this->override_other = _arg;
    return *this;
  }
  Type & set__fault(
    const bool & _arg)
  {
    this->fault = _arg;
    return *this;
  }
  Type & set__bad_crc(
    const bool & _arg)
  {
    this->bad_crc = _arg;
    return *this;
  }
  Type & set__degraded(
    const bool & _arg)
  {
    this->degraded = _arg;
    return *this;
  }
  Type & set__cmd_src(
    const ds_dbw_msgs::msg::CmdSrc_<ContainerAllocator> & _arg)
  {
    this->cmd_src = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::GearReport_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::GearReport_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::GearReport_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::GearReport_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__GearReport
    std::shared_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__GearReport
    std::shared_ptr<ds_dbw_msgs::msg::GearReport_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GearReport_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->gear != other.gear) {
      return false;
    }
    if (this->cmd != other.cmd) {
      return false;
    }
    if (this->driver != other.driver) {
      return false;
    }
    if (this->reject != other.reject) {
      return false;
    }
    if (this->power_latched != other.power_latched) {
      return false;
    }
    if (this->external_control != other.external_control) {
      return false;
    }
    if (this->ready != other.ready) {
      return false;
    }
    if (this->override_active != other.override_active) {
      return false;
    }
    if (this->override_other != other.override_other) {
      return false;
    }
    if (this->fault != other.fault) {
      return false;
    }
    if (this->bad_crc != other.bad_crc) {
      return false;
    }
    if (this->degraded != other.degraded) {
      return false;
    }
    if (this->cmd_src != other.cmd_src) {
      return false;
    }
    return true;
  }
  bool operator!=(const GearReport_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GearReport_

// alias to use template instance with default allocator
using GearReport =
  ds_dbw_msgs::msg::GearReport_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__STRUCT_HPP_
