// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from ds_dbw_msgs:msg/GearReport.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__TRAITS_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "ds_dbw_msgs/msg/detail/gear_report__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'gear'
// Member 'cmd'
// Member 'driver'
#include "ds_dbw_msgs/msg/detail/gear__traits.hpp"
// Member 'reject'
#include "ds_dbw_msgs/msg/detail/gear_reject__traits.hpp"
// Member 'cmd_src'
#include "ds_dbw_msgs/msg/detail/cmd_src__traits.hpp"

namespace ds_dbw_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const GearReport & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: gear
  {
    out << "gear: ";
    to_flow_style_yaml(msg.gear, out);
    out << ", ";
  }

  // member: cmd
  {
    out << "cmd: ";
    to_flow_style_yaml(msg.cmd, out);
    out << ", ";
  }

  // member: driver
  {
    out << "driver: ";
    to_flow_style_yaml(msg.driver, out);
    out << ", ";
  }

  // member: reject
  {
    out << "reject: ";
    to_flow_style_yaml(msg.reject, out);
    out << ", ";
  }

  // member: power_latched
  {
    out << "power_latched: ";
    rosidl_generator_traits::value_to_yaml(msg.power_latched, out);
    out << ", ";
  }

  // member: external_control
  {
    out << "external_control: ";
    rosidl_generator_traits::value_to_yaml(msg.external_control, out);
    out << ", ";
  }

  // member: ready
  {
    out << "ready: ";
    rosidl_generator_traits::value_to_yaml(msg.ready, out);
    out << ", ";
  }

  // member: override_active
  {
    out << "override_active: ";
    rosidl_generator_traits::value_to_yaml(msg.override_active, out);
    out << ", ";
  }

  // member: override_other
  {
    out << "override_other: ";
    rosidl_generator_traits::value_to_yaml(msg.override_other, out);
    out << ", ";
  }

  // member: fault
  {
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
    out << ", ";
  }

  // member: bad_crc
  {
    out << "bad_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_crc, out);
    out << ", ";
  }

  // member: degraded
  {
    out << "degraded: ";
    rosidl_generator_traits::value_to_yaml(msg.degraded, out);
    out << ", ";
  }

  // member: cmd_src
  {
    out << "cmd_src: ";
    to_flow_style_yaml(msg.cmd_src, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GearReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: gear
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "gear:\n";
    to_block_style_yaml(msg.gear, out, indentation + 2);
  }

  // member: cmd
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd:\n";
    to_block_style_yaml(msg.cmd, out, indentation + 2);
  }

  // member: driver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "driver:\n";
    to_block_style_yaml(msg.driver, out, indentation + 2);
  }

  // member: reject
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reject:\n";
    to_block_style_yaml(msg.reject, out, indentation + 2);
  }

  // member: power_latched
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "power_latched: ";
    rosidl_generator_traits::value_to_yaml(msg.power_latched, out);
    out << "\n";
  }

  // member: external_control
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "external_control: ";
    rosidl_generator_traits::value_to_yaml(msg.external_control, out);
    out << "\n";
  }

  // member: ready
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "ready: ";
    rosidl_generator_traits::value_to_yaml(msg.ready, out);
    out << "\n";
  }

  // member: override_active
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_active: ";
    rosidl_generator_traits::value_to_yaml(msg.override_active, out);
    out << "\n";
  }

  // member: override_other
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "override_other: ";
    rosidl_generator_traits::value_to_yaml(msg.override_other, out);
    out << "\n";
  }

  // member: fault
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "fault: ";
    rosidl_generator_traits::value_to_yaml(msg.fault, out);
    out << "\n";
  }

  // member: bad_crc
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "bad_crc: ";
    rosidl_generator_traits::value_to_yaml(msg.bad_crc, out);
    out << "\n";
  }

  // member: degraded
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "degraded: ";
    rosidl_generator_traits::value_to_yaml(msg.degraded, out);
    out << "\n";
  }

  // member: cmd_src
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "cmd_src:\n";
    to_block_style_yaml(msg.cmd_src, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GearReport & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace ds_dbw_msgs

namespace rosidl_generator_traits
{

[[deprecated("use ds_dbw_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const ds_dbw_msgs::msg::GearReport & msg,
  std::ostream & out, size_t indentation = 0)
{
  ds_dbw_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use ds_dbw_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const ds_dbw_msgs::msg::GearReport & msg)
{
  return ds_dbw_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<ds_dbw_msgs::msg::GearReport>()
{
  return "ds_dbw_msgs::msg::GearReport";
}

template<>
inline const char * name<ds_dbw_msgs::msg::GearReport>()
{
  return "ds_dbw_msgs/msg/GearReport";
}

template<>
struct has_fixed_size<ds_dbw_msgs::msg::GearReport>
  : std::integral_constant<bool, has_fixed_size<ds_dbw_msgs::msg::CmdSrc>::value && has_fixed_size<ds_dbw_msgs::msg::Gear>::value && has_fixed_size<ds_dbw_msgs::msg::GearReject>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<ds_dbw_msgs::msg::GearReport>
  : std::integral_constant<bool, has_bounded_size<ds_dbw_msgs::msg::CmdSrc>::value && has_bounded_size<ds_dbw_msgs::msg::Gear>::value && has_bounded_size<ds_dbw_msgs::msg::GearReject>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<ds_dbw_msgs::msg::GearReport>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // DS_DBW_MSGS__MSG__DETAIL__GEAR_REPORT__TRAITS_HPP_
