// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ds_dbw_msgs:msg/MiscCmd.idl
// generated code does not contain a copyright notice

#ifndef DS_DBW_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_HPP_
#define DS_DBW_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'turn_signal'
#include "ds_dbw_msgs/msg/detail/turn_signal__struct.hpp"
// Member 'parking_brake'
#include "ds_dbw_msgs/msg/detail/prk_brk_cmd__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__ds_dbw_msgs__msg__MiscCmd __attribute__((deprecated))
#else
# define DEPRECATED__ds_dbw_msgs__msg__MiscCmd __declspec(deprecated)
#endif

namespace ds_dbw_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MiscCmd_
{
  using Type = MiscCmd_<ContainerAllocator>;

  explicit MiscCmd_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    turn_signal(_init),
    parking_brake(_init)
  {
    (void)_init;
  }

  explicit MiscCmd_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    turn_signal(_alloc, _init),
    parking_brake(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _turn_signal_type =
    ds_dbw_msgs::msg::TurnSignal_<ContainerAllocator>;
  _turn_signal_type turn_signal;
  using _parking_brake_type =
    ds_dbw_msgs::msg::PrkBrkCmd_<ContainerAllocator>;
  _parking_brake_type parking_brake;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__turn_signal(
    const ds_dbw_msgs::msg::TurnSignal_<ContainerAllocator> & _arg)
  {
    this->turn_signal = _arg;
    return *this;
  }
  Type & set__parking_brake(
    const ds_dbw_msgs::msg::PrkBrkCmd_<ContainerAllocator> & _arg)
  {
    this->parking_brake = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> *;
  using ConstRawPtr =
    const ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ds_dbw_msgs__msg__MiscCmd
    std::shared_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ds_dbw_msgs__msg__MiscCmd
    std::shared_ptr<ds_dbw_msgs::msg::MiscCmd_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MiscCmd_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->turn_signal != other.turn_signal) {
      return false;
    }
    if (this->parking_brake != other.parking_brake) {
      return false;
    }
    return true;
  }
  bool operator!=(const MiscCmd_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MiscCmd_

// alias to use template instance with default allocator
using MiscCmd =
  ds_dbw_msgs::msg::MiscCmd_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace ds_dbw_msgs

#endif  // DS_DBW_MSGS__MSG__DETAIL__MISC_CMD__STRUCT_HPP_
